//+------------------------------------------------------------------+
//|                                                          rmo.mq4 |
//|                                                           mladen |
//| Rahul Mohindar Oscillator                                        |
//| originaly developed by : ????????                                |
//+------------------------------------------------------------------+
#property copyright "copyleft mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers 5
#property indicator_color1 Green
#property indicator_color2 Red
#property indicator_color3 DimGray
#property indicator_color4 Lime
#property indicator_color5 Gold
#property indicator_width1 2
#property indicator_width2 2
#property indicator_width3 2
#property indicator_style5 STYLE_DOT

//
//
//
//
//

extern int    MALength                   = 2;
extern int    Depth                      = 10;
extern int    SignalsSmooth              = 30;
extern int    Smooth                     = 81;
extern int    Price                      = PRICE_CLOSE;
extern bool   ShowRMO                    = true;
extern bool   ShowSignals                = true;

extern bool   alertsOn                   = true;
extern bool   alertsOnZeroCross          = true;
extern bool   alertsOnSignalCross        = true;
extern bool   alertsOnCurrent            = true;
extern bool   alertsMessage              = true;
extern bool   alertsSound                = true;
extern bool   alertsEmail                = false;

extern bool   ShowArrows                 = true;
extern bool   arrowsOnZeroCross          = true;
extern bool   arrowsOnSignalCross        = true;
extern string arrowsIdentifier           = "rmo arrows1";
extern double arrowsUpperGap             = 0.5;
extern double arrowsLowerGap             = 0.5;
extern color  arrowsOnZeroCrossUpColor   = LimeGreen;
extern color  arrowsOnZeroCrossDnColor   = Red;
extern int    arrowsOnZeroCrossUpCode    = 241;
extern int    arrowsOnZeroCrossDnCode    = 242;
extern color  arrowsOnSignalCrossUpColor = LimeGreen;
extern color  arrowsOnSignalCrossDnColor = Red;
extern int    arrowsOnSignalCrossUpCode  = 159;
extern int    arrowsOnSignalCrossDnCode  = 159;

//
//
//
//
//

#define MAX_depth 30
double  buffer1[];
double  buffer2[];
double  buffer3[];
double  buffer4[];
double  buffer5[];
double  buffer6[];
double  buffer7[];
double  pBuffer[][MAX_depth];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,buffer1);
      SetIndexBuffer(1,buffer2);
      SetIndexBuffer(2,buffer3);
      SetIndexBuffer(3,buffer4);
      SetIndexBuffer(4,buffer5);
      SetIndexBuffer(5,buffer6);
      SetIndexBuffer(6,buffer7);
      
      //
      //
      //
      //
      //

      if (!ShowSignals) ShowRMO = true;      
      if (ShowRMO)
      {
         SetIndexStyle(0,DRAW_HISTOGRAM);
         SetIndexStyle(1,DRAW_HISTOGRAM);
         SetIndexStyle(2,DRAW_LINE);
      }
      else
      {
         SetIndexStyle(0,DRAW_NONE);
         SetIndexStyle(1,DRAW_NONE);
         SetIndexStyle(2,DRAW_NONE);
      }
      if (ShowSignals)
      {
         SetIndexStyle(3,DRAW_LINE);
         SetIndexStyle(4,DRAW_LINE);
      }
      else
      {
         SetIndexStyle(3,DRAW_NONE);
         SetIndexStyle(4,DRAW_NONE);
      }
      
      //
      //
      //
      //
      //
      
         MALength = MathMax(MALength,2);
         Depth    = MathMax(MathMin(Depth,MAX_depth),2);
   IndicatorShortName("rmo ("+MALength+","+Depth+","+Smooth+")");
   return(0);
}
int deinit()
{ 
   deleteArrows();  
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double trend[][2];
#define _signal 0
#define _zeroli 1

int start()
{
   double alpha = 2.0/(Smooth+1.0);
   double alphs = 2.0/(SignalsSmooth+1.0);
   int    counted_bars=IndicatorCounted();
   int    i,l,r;


   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           int limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArrayRange(pBuffer,0) != Bars) ArrayResize(pBuffer,Bars);
           if (ArrayRange(trend,0)!=Bars) ArrayResize(trend,Bars);

   //
   //
   //
   //
   //
   
   for(i=limit, r=Bars-limit-1; i>=0; i--,r++)
   {
      buffer7[i] = iMA(NULL,0,1,0,MODE_SMA,Price,i);
      double high   = buffer7[ArrayMaximum(buffer7,Depth,i)];
      double low    = buffer7[ArrayMinimum(buffer7,Depth,i)];
      double price  = buffer7[i];
      double sum    = 0;
      
      //
      //
      //
      //
      //
      
      for (int k=1; k<=Depth; k++)
      {
         pBuffer[r][k-1] = price;
         if (r>MALength)
         {
            for (l=0, price=0; l<MALength; l++) price += pBuffer[r-l][k-1];
                                                price /= MALength;
         }               
         sum += price;
      }
      
      //
      //
      //
      //
      //
      
      if ((high-low) != 0)
            buffer6[i] = 100*(buffer7[i]-sum/Depth)/(high-low);
      else  buffer6[i] = 0;
      buffer4[i] = buffer4[i+1]+alphs*(buffer6[i]-buffer4[i+1]);
      buffer5[i] = buffer5[i+1]+alphs*(buffer4[i]-buffer5[i+1]);
      buffer3[i] = buffer3[i+1]+alpha*(buffer6[i]-buffer3[i+1]);
      
      trend[r][_zeroli] = trend[r-1][_zeroli];
      trend[r][_signal] = trend[r-1][_signal];
         if (buffer3[i]>0)           trend[r][_zeroli] =  1;
         if (buffer3[i]<0)           trend[r][_zeroli] = -1;
         if (buffer4[i]>buffer5[i])  trend[r][_signal] =  1;
         if (buffer4[i]<buffer5[i])  trend[r][_signal] = -1;
         if (trend[r][_zeroli] == 1) buffer1[i] = buffer3[i];
         if (trend[r][_zeroli] ==-1) buffer2[i] = buffer3[i];
         
         //
         //
         //
         //
         //
         
         //
           //
           //
           //
           //
           
           if (ShowArrows)
           {
              ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
              ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
              string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
              if (arrowsOnZeroCross && trend[r][_zeroli] != trend[r-1][_zeroli])
              {
                 if (trend[r][_zeroli] == 1) drawArrow("1",0.5,i,arrowsOnZeroCrossUpColor,arrowsOnZeroCrossUpCode,false);
                 if (trend[r][_zeroli] ==-1) drawArrow("1",0.5,i,arrowsOnZeroCrossDnColor,arrowsOnZeroCrossDnCode, true);
              } 
              if (arrowsOnSignalCross && trend[r][_signal] != trend[r-1][_signal])
              {
                 if (trend[r][_signal] == 1) drawArrow("2",1,i,arrowsOnSignalCrossUpColor,arrowsOnSignalCrossUpCode,false);
                 if (trend[r][_signal] ==-1) drawArrow("2",1,i,arrowsOnSignalCrossDnColor,arrowsOnSignalCrossDnCode, true);
              } 
           }                                     
      
   }
   manageAlerts();
   return(0);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = Bars-whichBar-1;
      
      //
      //
      //
      //
      //
            
      if (alertsOnZeroCross && trend[whichBar][_zeroli] != trend[whichBar-1][_zeroli])
      {
         static datetime time1 = 0;
         static string   mess1 = "";
            if (trend[whichBar][_zeroli] ==  1) doAlert(time1,mess1," RMO crossed zero line up");
            if (trend[whichBar][_zeroli] == -1) doAlert(time1,mess1," RMO crossed zero line down");
      }
      if (alertsOnSignalCross && trend[whichBar][_signal] != trend[whichBar-1][_signal])
      {
         static datetime time2 = 0;
         static string   mess2 = "";
            if (trend[whichBar][_signal] ==  1) doAlert(time2,mess2," RMO crossed signal line up");
            if (trend[whichBar][_signal] == -1) doAlert(time2,mess2," RMO crossed signal line down");
      }
   }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[0]) {
       previousAlert  = doWhat;
       previousTime   = Time[0];

       //
       //
       //
       //
       //

       message =  Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(Symbol()+" RMO ",message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------          
//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}





   